unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label1: TLabel;
    edtFrom: TEdit;
    edtTo: TEdit;
    Label2: TLabel;
    edtSubject: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    memBody: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    OpenDialog3: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses
  SMIMEModule,
  IdMessage;

{$R *.dfm}

procedure TfrmMain.Button1Click(Sender: TObject);
var
  lMsg: TIdMessage;
begin
  if OpenDialog1.Execute then begin
    lMsg := nil;
    try
      lMsg := dmSMIME.LoadEml(OpenDialog1.FileName);
      edtTo.Text := lMsg.Recipients.EMailAddresses;
      edtFrom.Text := lMsg.From.Text;
      edtSubject.Text := lMsg.Subject;
      memBody.Text := lMsg.Body.Text;
    finally
      lMsg.Free;
    end;
  end;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
var
  lMsg: TIdMessage;
begin
  if SaveDialog1.Execute then begin
    lMsg := TIdMessage.Create(nil);
    try
      lMsg.Recipients.Add.Text := edtTo.Text;
      lMsg.From.Text := edtFrom.Text;
      lMsg.Subject := edtSubject.Text;
      lMsg.Body.Assign(memBody.Lines);
      dmSMIME.SaveEml(lMsg,SaveDialog1.FileName);
    finally
      lMsg.Free;
    end;
  end;
end;

procedure TfrmMain.Button3Click(Sender: TObject);
begin
  if OpenDialog2.Execute then
    dmSMIME.ImportPFX(OpenDialog2.Filename);
end;

procedure TfrmMain.Button4Click(Sender: TObject);
begin
  if OpenDialog3.Execute then
    dmSMIME.ImportCer(OpenDialog3.Filename);
end;

procedure TfrmMain.Button5Click(Sender: TObject);
begin
  if OpenDialog3.Execute then
    dmSMIME.ImportRoot(OpenDialog3.Filename);
end;

end.
